diff --git a/Manifests/Manifest_LAOS-15.1.xml b/Manifests/Manifest_LAOS-15.1.xml
new file mode 100644
index 00000000..ead70fe0
--- /dev/null
+++ b/Manifests/Manifest_LAOS-15.1.xml
@@ -0,0 +1,216 @@
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+ s
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
diff --git a/Scripts/LineageOS-14.1/Patch.sh b/Scripts/LineageOS-14.1/Patch.sh
index 2d246831..1a81df8c 100755
--- a/Scripts/LineageOS-14.1/Patch.sh
+++ b/Scripts/LineageOS-14.1/Patch.sh
@@ -21,6 +21,8 @@
#Delete Everything and Sync
#resetWorkspace
+#repopick -t n_asb_02-2018
+
#Apply all of our changes
#patchWorkspace
@@ -111,6 +113,7 @@ sed -i 's/ln -s /ln -sf /' Android.mk;
sed -i 's/ext.androidBuildVersionTools = "24.0.3"/ext.androidBuildVersionTools = "25.0.3"/' build.gradle;
enterAndClear "packages/apps/FDroid"
+git checkout 6260c11efc0f8296c19ee8d075cafbc556869cd1
patch -p1 < $patches"android_packages_apps_FDroid/0001.patch" #Mark as privileged
cp $patches"android_packages_apps_FDroid/default_repos.xml" app/src/main/res/values/default_repos.xml; #Add extra repos
sed -i 's|gradle|./gradlew|' Android.mk; #Gradle 4.0 fix
@@ -219,7 +222,7 @@ cd $base
find "device" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'enhanceLocation "$0"' {} \;
find "device" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'enableDexPreOpt "$0"' {} \;
find "device" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'enableForcedEncryption "$0"' {} \;
-find "device" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'enableStrongEncryption "$0"' {} \;
+#find "device" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'enableStrongEncryption "$0"' {} \;
find "kernel" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'hardenDefconfig "$0"' {} \;
cd $base
diff --git a/Scripts/LineageOS-15.1/00init.sh b/Scripts/LineageOS-15.1/00init.sh
new file mode 100644
index 00000000..dbaa5865
--- /dev/null
+++ b/Scripts/LineageOS-15.1/00init.sh
@@ -0,0 +1,49 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2017-2018 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+#Sets settings used by all other scripts
+
+export androidWorkspace="/mnt/Drive-3/";
+export base=$androidWorkspace"Build/LineageOS-15.1/";
+
+export SIGNING_KEY_DIR=$androidWorkspace"Signing_Keys";
+export OTA_PACKAGE_SIGNING_KEY=$SIGNING_KEY_DIR"/releasekey"
+
+export patches=$androidWorkspace"Patches/LineageOS-15.1/";
+export cvePatchesLinux=$androidWorkspace"Patches/Linux/";
+export cvePatchesAndroid=$androidWorkspace"Patches/Android/";
+export dosWallpapers=$androidWorkspace"Patches/Wallpapers/";
+
+export scripts=$androidWorkspace"Scripts/LineageOS-15.1/";
+export cveScripts=$scripts"CVE_Patchers/";
+
+export ANDROID_HOME="/home/$USER/Android/Sdk";
+
+export KBUILD_BUILD_USER=emy
+export KBUILD_BUILD_HOST=dosbm
+
+export ANDROID_JACK_VM_ARGS="-Xmx6144m -Xms512m -Dfile.encoding=UTF-8 -XX:+TieredCompilation"
+export JACK_SERVER_VM_ARGUMENTS="${ANDROID_JACK_VM_ARGS}"
+
+export GRADLE_OPTS=-Xmx2048m
+
+source $scripts"/Functions.sh"
+
+unalias cp
+unalias mv
+unalias rm
+unalias ln
diff --git a/Scripts/LineageOS-15.1/Deblob.sh b/Scripts/LineageOS-15.1/Deblob.sh
new file mode 100755
index 00000000..d7fac1bd
--- /dev/null
+++ b/Scripts/LineageOS-15.1/Deblob.sh
@@ -0,0 +1,385 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2017-2018 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+#Goal: Remove as many proprietary blobs without breaking core functionality
+#Outcome: Increased battery/performance/privacy/security, Decreased ROM size
+#TODO: Clean init*.rc files, Modularize, Remove more variants
+
+#
+#Device Status (Tested under LineageOS 14.1)
+#
+#Functioning as Expected: bacon, clark, mako, marlin, sailfish, thor
+
+echo "Deblobbing..."
+
+#
+#START OF BLOBS ARRAY
+#
+ #WARNING: STRAY DELIMITERS WILL RESULT IN FILE DELETIONS
+ blobs=""; #Delimited using "|"
+ makes="";
+ overlay="";
+ kernels=""; #Delimited using " "
+
+ #ACDB (Audio Configurations) [Qualcomm] XXX: Breaks audio output
+ #blobs=$blobs"acdb";
+
+ #ADSP/Hexagon (Hardware Audio Decoding) [Qualcomm]
+ #blobs=$blobs"adsprpcd|libadsprpc.so|libadsprpc.so|libfastcvadsp_stub.so|libfastcvopt.so|libadsp_fd_skel.so";
+
+ #Alipay (Payment Platform) [Alibaba]
+ blobs=$blobs"alipay.b00|alipay.b01|alipay.b02|alipay.b03|alipay.b04|alipay.b05|alipay.b06|alipay.mdt";
+
+ #aptX (Bluetooth Audio Compression Codec) [Qualcomm]
+ blobs=$blobs"|libaptX-1.0.0-rel-Android21-ARMv7A.so|libaptXHD-1.0.0-rel-Android21-ARMv7A.so|libaptXScheduler.so";
+
+ #ATFWD [Qualcomm]
+ blobs=$blobs"|ATFWD-daemon|atfwd.apk";
+
+ #AudioFX (Audio Effects) [Qualcomm] XXX: Breaks audio on some devices
+ #blobs=$blobs"|libqcbassboost.so|libqcreverb.so|libqcvirt.so";
+
+ #Camera
+ #Attempted, don't waste your time...
+ #FUN FACT: The Huawei Honor 5x ships with eight-hundred-and-thirty-five (*835*) proprietary camera blobs.
+ #blobs=$blobs"|";
+
+ #Clearkey (DRM) [Google]
+ blobs=$blobs"|libdrmclearkeyplugin.so";
+
+ #CMN (TrustZone?) [Qualcomm?]
+ #blobs=$blobs"|cmnlib.b00|cmnlib.b01|cmnlib.b02|cmnlib.b03|cmnlib.b04|cmnlib.b05|cmnlib.flist|cmnlib.mdt|cmnlib64.b00|cmnlib64.b01|cmnlib64.b02|cmnlib64.b03|cmnlib64.b04|cmnlib64.b05|cmnlib64.flist|cmnlib64.mdt";
+
+ #CNE (Automatic Cell/Wi-Fi Switching) [Qualcomm]
+ #blobs=$blobs"|libcneapiclient.so|libNimsWrap.so"; #XXX: Breaks radio
+ blobs=$blobs"|andsfCne.xml|ATT_profile1.xml|ATT_profile2.xml|ATT_profile3.xml|ATT_profile4.xml|ATT_profiles.xml|cnd|cneapiclient.jar|cneapiclient.xml|CNEService.apk|com.quicinc.cne.jar|com.quicinc.cne.xml|ConnectivityExt.jar|ConnectivityExt.xml|libcneconn.so|libcneqmiutils.so|libcne.so|libvendorconn.so|libwqe.so|profile1.xml|profile2.xml|profile3.xml|profile4.xml|profile5.xml|ROW_profile1.xml|ROW_profile2.xml|ROW_profile3.xml|ROW_profile4.xml|ROW_profile5.xml|ROW_profiles.xml|SwimConfig.xml|VZW_profile1.xml|VZW_profile2.xml|VZW_profile3.xml|VZW_profile4.xml|VZW_profile5.xml|VZW_profile6.xml|VZW_profiles.xml";
+ makes=$makes"libcnefeatureconfig";
+
+ #Diagnostics [Qualcomm]
+ blobs=$blobs"|[/]diag[/]|diag_callback_client|diag_dci_sample|diag_klog|diag_mdlog|diag_mdlog-getlogs|diag_mdlog-wrap|diag[/]mdm|diag_qshrink4_daemon|diag_socket_log|diag_uart_log|drmdiagapp|ibdrmdiag.so|ssr_diag|test_diag";
+
+ #Dirac (Audio Effects) [Dirac]
+ blobs=$blobs"|diracmobile.config|libDiracAPI_SHARED.so|libdirac.so|libdirac-appi.so";
+
+ #Discretix (DRM/HDCP) [Discretix Technologies]
+ blobs=$blobs"|discretix|DxHDCP.cfg|libDxHdcp.so";
+ blobs=$blobs"|dxhdcp2.b00|dxhdcp2.b01|dxhdcp2.b02|dxhdcp2.b03|dxhdcp2.mdt";
+ blobs=$blobs"|dxcprm.b00|dxcprm.b01|dxcprm.b02|dxcprm.b03|dxcprm.mdt";
+
+ #Display Color Tuning [Qualcomm]
+ blobs=$blobs"|colorservice.apk|com.qti.snapdragon.sdk.display.jar|com.qti.snapdragon.sdk.display.xml|libdisp-aba.so|libmm-abl-oem.so|libmm-abl.so|libmm-als.so|libmm-color-convertor.so|libmm-disp-apis.so|libmm-qdcm.so|libsd_sdk_display.so|mm-pp-daemon|mm-pp-dpps|PPPreference.apk";
+
+ #DivX (DRM) [DivX]
+ blobs=$blobs"|libDivxDrm.so|libSHIMDivxDrm.so";
+
+ #DPM (Data Power Management) [Qualcomm]
+ blobs=$blobs"|com.qti.dpmframework.jar|com.qti.dpmframework.xml|dpmapi.jar|dpmapi.xml|dpm.conf|dpmd|dpmserviceapp.apk|libdpmctmgr.so|libdpmfdmgr.so|libdpmframework.so|libdpmnsrm.so|libdpmtcm.so|NsrmConfiguration.xml|tcmclient.jar";
+
+ #DRM
+ blobs=$blobs"|lib-sec-disp.so|libSecureUILib.so|libsecureui.so|libsecureuisvc_jni.so|libsecureui_svcsock.so";
+ blobs=$blobs"|liboemcrypto.so|libtzdrmgenprov.so";
+ blobs=$blobs"|libpvr.so|librmp.so|libsi.so|libSSEPKCS11.so";
+
+ #Face Unlock [Google]
+ blobs=$blobs"|libfacenet.so|libfilterpack_facedetect.so|libfrsdk.so";
+
+ #GPS [Qualcomm]
+ #blobs=$blobs"|flp.conf|flp.default.so|flp.msm8084.so|flp.msm8960.so|gpsd|gps.msm8084.so|gps.msm8960.so|libflp.so|libgps.utils.so|libloc_api_v02.so|libloc_core.so|libloc_ds_api.so|libloc_eng.so|libloc_ext.so";
+
+ #HDCP (DRM)
+ blobs=$blobs"|libmm-hdcpmgr.so";
+ blobs=$blobs"|hdcp1.b00|hdcp1.b01|hdcp1.b02|hdcp1.b03|hdcp1.b04|hdcp1.b05|hdcp1.b06|hdcp1.mdt|tzhdcp.b00|tzhdcp.b01|tzhdcp.b02|tzhdcp.b03|tzhdcp.mdt";
+
+ #[HTC]
+ blobs=$blobs"|gptauuid.xml";
+ blobs=$blobs"|htc_drmprov.b00|htc_drmprov.b01|htc_drmprov.b02|htc_drmprov.b03|htc_drmprov.b04|htc_drmprov.b05|htc_drmprov.b06|htc_drmprov.mdt|gpsample.mbn";
+
+ #I/O Prefetcher [Qualcomm]
+ blobs=$blobs"|libqc-opt.so";
+ blobs=$blobs"|iop|libqti-iop-client.so|libqti-iop.so|QPerformance.jar";
+
+ #IMS (VoLTE/Wi-Fi Calling) [Qualcomm]
+ #blobs=$blobs"|ims.apk|ims.xml|libimsmedia_jni.so"; #IMS (Core) (To support carriers that have phased out 2G)
+ blobs=$blobs"|imscmlibrary.jar|imscmservice|imscm.xml|imsdatadaemon|imsqmidaemon|imssettings.apk|lib-imsdpl.so|lib-imscamera.so|libimscamera_jni.so|lib-imsqimf.so|lib-imsSDP.so|lib-imss.so|lib-imsvt.so|lib-imsxml.so"; #IMS
+ blobs=$blobs"|ims_rtp_daemon|lib-rtpcommon.so|lib-rtpcore.so|lib-rtpdaemoninterface.so|lib-rtpsl.so"; #RTP
+ blobs=$blobs"|lib-dplmedia.so|librcc.so|libvcel.so|libvoice-svc.so|qti_permissions.xml"; #Misc.
+ #blobs=$blobs"|volte_modem[/]";
+
+ #IPA (Internet Packet Accelerator) [Qualcomm]
+ #This is actually open source (excluding -diag)
+ #blobs=$blobs"|ipacm";
+ blobs=$blobs"|ipacm-diag";
+ #makes=$makes"|ipacm|IPACM_cfg.xml";
+ #kernels=$kernels" drivers/platform/msm/ipa";
+
+ #Keystore/TrustZone (HW Crypto) [Qualcomm]
+ #blobs=$blobs"|qseecomd|keystore.qcom.so|libdrmdecrypt.so|libdrmfs.so|libdrmtime.so|libQSEEComAPI.so|librpmb.so|libssd.so";
+ #blobs=$blobs"|keymaster.b00|keymaster.b01|keymaster.b02|keymaster.b03|keymaster.flist|keymaster.mdt";
+ #blobs=$blobs"|tzapps.b00|tzapps.b01|tzapps.b02|tzapps.b03|tzapps.mdt";
+
+ #Location (gpsOne/gpsOneXTRA/IZat/Lumicast/QUIP) [Qualcomm]
+ blobs=$blobs"|cacert_location.pem|com.qti.location.sdk.jar|com.qti.location.sdk.xml|com.qualcomm.location.apk|com.qualcomm.location.xml|com.qualcomm.services.location.apk|gpsone_daemon|izat.conf|izat.xt.srv.jar|izat.xt.srv.xml|libalarmservice_jni.so|libasn1cper.so|libasn1crt.so|libasn1crtx.so|libdataitems.so|libdrplugin_client.so|libDRPlugin.so|libevent_observer.so|libgdtap.so|libgeofence.so|libizat_core.so|liblbs_core.so|liblocationservice_glue.so|liblocationservice.so|libloc_ext.so|libloc_xtra.so|liblowi_client.so|liblowi_wifihal_nl.so|liblowi_wifihal.so|libquipc_os_api.so|libquipc_ulp_adapter.so|libulp2.so|libxtadapter.so|libxt_native.so|libxtwifi_ulp_adaptor.so|libxtwifi_zpp_adaptor.so|location-mq|loc_launcher|lowi.conf|lowi-server|slim_ap_daemon|slim_daemon|xtra_root_cert.pem|xtra_t_app.apk|xtwifi.conf|xtwifi-client|xtwifi-inet-agent";
+ overlay=$overlay"config_comboNetworkLocationProvider|config_enableFusedLocationOverlay|config_enableNetworkLocationOverlay|config_fusedLocationProviderPackageName|config_enableNetworkLocationOverlay|config_networkLocationProviderPackageName|com.qualcomm.location";
+
+ #Misc
+ blobs=$blobs"|libjni_latinime.so|libuiblur.so|libwifiscanner.so";
+
+ #[Motorola]
+ blobs=$blobs"|AppDirectedSMSProxy.apk|BuaContactAdapter.apk|batt_health|com.motorola.DirectedSMSProxy.xml|com.motorola.motosignature.jar|com.motorola.motosignature.xml|com.motorola.camera.xml|com.motorola.gallery.xml|com.motorola.msimsettings.xml|com.motorola.triggerenroll.xml|MotoDisplayFWProxy.apk|MotoSignatureApp.apk|TriggerEnroll.apk|TriggerTrainingService.apk";
+ makes=$makes"|com.motorola.cameraone.xml";
+
+ #Performance [Qualcomm]
+ #blobs=$blobs"|msm_irqbalance";
+ #Devices utilizing perfd won't hotplug cores without it
+ #Attempted to replace this with showp1984's msm_mpdecision, but the newer kernels simply don't have the mach_msm dependencies that are needed
+ #blobs=$blobs"|mpdecision|libqti-perfd-client.so|perfd|perf-profile0.conf|perf-profile1.conf|perf-profile2.conf|perf-profile3.conf|perf-profile4.conf|perf-profile5.conf";
+
+ #Playready (DRM) [Microsoft]
+ blobs=$blobs"|libtzplayready.so"
+ blobs=$blobs"|playread.b00|playread.b01|playread.b02|playread.b03|playread.mdt";
+
+ #Project Fi [Google]
+ blobs=$blobs"|Tycho.apk";
+
+ #Quickboot [Qualcomm]
+ blobs=$blobs"|QuickBoot.apk";
+
+ #QTI (Tethering Extensions) [Qualcomm]
+ blobs=$blobs"|libQtiTether.so|QtiTetherService.apk";
+
+ #RCS (Proprietary messaging protocol)
+ blobs=$blobs"|rcsimssettings.jar|rcsimssettings.xml|rcsservice.jar|rcsservice.xml|lib-imsrcscmclient.so|lib-ims-rcscmjni.so|lib-imsrcscmservice.so|lib-imsrcscm.so|lib-imsrcs.so|lib-rcsimssjni.so|lib-rcsjni.so"; #RCS
+
+ #SecProtect [Qualcomm]
+ blobs=$blobs"|SecProtect.apk";
+
+ #SecureUI Frontends
+ blobs=$blobs"|libHealthAuthClient.so|libHealthAuthJNI.so|libSampleAuthJNI.so|libSampleAuthJNIv1.so|libSampleExtAuthJNI.so|libSecureExtAuthJNI.so|libSecureSampleAuthClient.so";
+
+ #SoundFX [Sony]
+ blobs=$blobs"|libsonypostprocbundle.so|libsonysweffect.so";
+
+ #[Sprint]
+ blobs=$blobs"|com.android.omadm.service.xml|ConnMO.apk|CQATest.apk|DCMO.apk|DiagMon.apk|DMConfigUpdate.apk|DMService.apk|GCS.apk|HiddenMenu.apk|libdmengine.so|libdmjavaplugin.so|LifetimeData.apk|SprintDM.apk|SprintHM.apk|whitelist_com.android.omadm.service.xml";
+
+ #Thermal Throttling [Qualcomm]
+ #blobs=$blobs"|libthermalclient.so|libthermalioctl.so|thermal-engine";
+
+ #Time Service [Qualcomm]
+ #Requires that https://github.com/LineageOS/android_hardware_sony_timekeep be included in repo manifest
+ #blobs=$blobs"|libtime_genoff.so"; #XXX: Breaks radio
+ #blobs=$blobs"|libTimeService.so|time_daemon|TimeService.apk";
+
+ #Venus (Hardware Video Decoding) [Qualcomm]
+ #blobs=$blobs"|venus.b00|venus.b01|venus.b02|venus.b03|venus.b04|venus.mbn|venus.mdt";
+
+ #[Verizon]
+ blobs=$blobs"|com.qualcomm.location.vzw_library.jar|com.qualcomm.location.vzw_library.xml|com.verizon.apn.xml|com.verizon.embms.xml|com.verizon.hardware.telephony.ehrpd.jar|com.verizon.hardware.telephony.ehrpd.xml|com.verizon.hardware.telephony.lte.jar|com.verizon.hardware.telephony.lte.xml|com.verizon.ims.jar|com.verizon.ims.xml|com.verizon.provider.xml|com.vzw.vzwapnlib.xml|qti-vzw-ims-internal.jar|qti-vzw-ims-internal.xml|VerizonUnifiedSettings.jar|VZWAPNLib.apk|VZWAPNService.apk|VZWAVS.apk|VzwLcSilent.apk|vzw_msdc_api.apk|VzwOmaTrigger.apk|vzw_sso_permissions.xml";
+
+ #Voice Recognition
+ blobs=$blobs"|aonvr1.bin|aonvr2.bin|audiomonitor|es305_fw.bin|HotwordEnrollment.apk|HotwordEnrollmentRT5677.apk|libadpcmdec.so|liblistenhardware.so|liblistenjni.so|liblisten.so|liblistensoundmodel.so|libqvop-service.so|librecoglib.so|libsmwrapper.so|libsupermodel.so|libtrainingcheck.so|qvop-daemon|sound_trigger.primary.msm8916.so|sound_trigger.primary.msm8996.so";
+
+ #Vulkan [Qualcomm]
+ #blobs=$blobs"|libllvm-qgl.so|vulkan.msm*.so";
+
+ #Wfd (Wireless Display) [Qualcomm]
+ blobs=$blobs"|libmmparser_lite.so|libmmrtpdecoder.so|libmmrtpencoder.so|libmmwfdinterface.so|libmmwfdsinkinterface.so|libmmwfdsrcinterface.so|libwfdavenhancements.so|libwfdcommonutils.so|libwfdhdcpcp.so|libwfdmmsink.so|libwfdmmsrc.so|libwfdmmutils.so|libwfdnative.so|libwfdrtsp.so|libwfdservice.so|libwfdsm.so|libwfduibcinterface.so|libwfduibcsinkinterface.so|libwfduibcsink.so|libwfduibcsrcinterface.so|libwfduibcsrc.so|WfdCommon.jar|wfdconfigsink.xml|wfdconfig.xml|wfdservice|WfdService.apk";
+
+ #Widevine (DRM) [Google]
+ blobs=$blobs"|com.google.widevine.software.drm.jar|com.google.widevine.software.drm.xml|libdrmclearkeyplugin.so|libdrmwvmplugin.so|libmarlincdmplugin.so|libwvdrmengine.so|libwvdrm_L1.so|libwvdrm_L3.so|libwvm.so|libWVphoneAPI.so|libWVStreamControlAPI_L1.so|libWVStreamControlAPI_L3.so";
+ blobs=$blobs"|tzwidevine.b00|tzwidevine.b01|tzwidevine.b02|tzwidevine.b03|tzwidevine.mdt|tzwvcpybuf.b00|tzwvcpybuf.b01|tzwvcpybuf.b02|tzwvcpybuf.b03|tzwvcpybuf.flist|tzwvcpybuf.mdt|widevine.b00|widevine.b01|widevine.b02|widevine.b03|widevine.b04|widevine.b05|widevine.b06|widevine.mbn|widevine.mdt";
+ makes=$makes"|libshim_wvm";
+
+ #WiPower (Wireless Charging) [Qualcomm]
+ blobs=$blobs"|a4wpservice.apk|com.quicinc.wbc.jar|com.quicinc.wbcserviceapp.apk|com.quicinc.wbcservice.jar|com.quicinc.wbcservice.xml|com.quicinc.wbc.xml|libwbc_jni.so|wbc_hal.default.so";
+ makes=$makes"|android.wipower|android.wipower.xml|com.quicinc.wbcserviceapps|libwipower_jni|wipowerservice";
+
+ export blobs;
+ export makes;
+ export overlay;
+ export kernels;
+#
+#END OF BLOBS ARRAY
+#
+
+#
+#START OF FUNCTIONS
+#
+deblobDevice() {
+ devicePath=$1;
+ cd $base$devicePath;
+ if [ "${PWD##*/}" == "flo" ] || [ "${PWD##*/}" == "mako" ] || [ "${PWD##*/}" == "kona-common" ] || [ "${PWD##*/}" == "n5110" ] || [ "${PWD##*/}" == "smdk4412-common" ] || [ "${PWD##*/}" == "hdx-common" ] || [ "${PWD##*/}" == "thor" ] || [ "${PWD##*/}" == "flounder" ]; then #Some devices don't need/like TimeKeep
+ replaceTime="false";
+ fi;
+ replaceTime="false"; #Temp disable replacement
+ if [ -f Android.mk ]; then
+ #Some devices store these in a dedicated firmware partition, others in /system/vendor/firmware, either way the following are just symlinks
+ #sed -i '/ALL_DEFAULT_INSTALLED_MODULES/s/$(CMN_SYMLINKS)//' Android.mk; #Remove CMN firmware
+ sed -i '/ALL_DEFAULT_INSTALLED_MODULES/s/$(DXHDCP2_SYMLINKS)//' Android.mk; #Remove Discretix firmware
+ #sed -i '/ALL_DEFAULT_INSTALLED_MODULES/s/$(IMS_SYMLINKS)//' Android.mk; #Remove IMS firmware
+ sed -i '/ALL_DEFAULT_INSTALLED_MODULES/s/$(PLAYREADY_SYMLINKS)//' Android.mk; #Remove Microsoft Playready firmware
+ sed -i '/ALL_DEFAULT_INSTALLED_MODULES/s/$(WIDEVINE_SYMLINKS)//' Android.mk; #Remove Google Widevine firmware
+ sed -i '/ALL_DEFAULT_INSTALLED_MODULES/s/$(WV_SYMLINKS)//' Android.mk; #Remove Google Widevine firmware
+ fi;
+ if [ -f BoardConfig.mk ]; then
+ if [ -z "$replaceTime" ]; then
+ sed -i 's/BOARD_USES_QC_TIME_SERVICES := true/BOARD_USES_QC_TIME_SERVICES := false/' BoardConfig.mk; #Switch to Sony TimeKeep
+ if ! grep -q "BOARD_USES_QC_TIME_SERVICES := false" BoardConfig.mk; then echo "BOARD_USES_QC_TIME_SERVICES := false" >> BoardConfig.mk; fi; #Switch to Sony TimeKeep
+ fi;
+ sed -i 's/BOARD_USES_QCNE := true/BOARD_USES_QCNE := false/' BoardConfig.mk; #Disable CNE
+ sed -i 's/BOARD_USES_WIPOWER := true/BOARD_USES_WIPOWER := false/' BoardConfig.mk; #Disable WiPower
+ fi;
+ if [ -f device.mk ]; then
+ awk -i inplace '!/'$makes'/' device.mk; #Remove all shim references from device makefile
+ if [ -z "$replaceTime" ]; then
+ #Switch to Sony TimeKeep
+ echo "PRODUCT_PACKAGES += \\" >> device.mk;
+ echo " timekeep \\" >> device.mk;
+ echo " TimeKeep" >> device.mk;
+ fi;
+ fi;
+ if [ -f "${PWD##*/}".mk ] && [ "${PWD##*/}".mk != "sepolicy" ]; then
+ awk -i inplace '!/'$makes'/' "${PWD##*/}".mk; #Remove all shim references from device makefile
+ if [ -z "$replaceTime" ]; then
+ #Switch to Sony TimeKeep
+ echo "PRODUCT_PACKAGES += \\" >> "${PWD##*/}".mk;
+ echo " timekeep \\" >> "${PWD##*/}".mk;
+ echo " TimeKeep" >> "${PWD##*/}".mk;
+ fi;
+ fi;
+ if [ -f system.prop ]; then
+ awk -i inplace '!/persist.loc.nlp_name/' system.prop; #Disable QC Location Provider
+ sed -i 's/drm.service.enabled=true/drm.service.enabled=false/' system.prop;
+ if ! grep -q "drm.service.enabled=false" system.prop; then echo "drm.service.enabled=false" >> system.prop; fi; #Disable DRM server
+ sed -i 's/persist.bt.enableAptXHD=true/persist.bt.enableAptXHD=false/' system.prop; #Disable aptX
+ sed -i 's/persist.cne.feature=./persist.cne.feature=0/' system.prop; #Disable CNE
+ sed -i 's/persist.dpm.feature=./persist.dpm.feature=0/' system.prop; #Disable DPM
+ sed -i 's/persist.gps.qc_nlp_in_use=./persist.gps.qc_nlp_in_use=0/' system.prop; #Disable QC Location Provider
+ sed -i 's/persist.sys.dpmd.nsrm=./persist.sys.dpmd.nsrm=0/' system.prop; #Disable DPM
+ sed -i 's/persist.rcs.supported=./persist.rcs.supported=0/' system.prop; #Disable RCS
+ sed -i 's/ro.bluetooth.emb_wp_mode=true/ro.bluetooth.emb_wp_mode=false/' system.prop; #Disable WiPower
+ sed -i 's/ro.bluetooth.wipower=true/ro.bluetooth.wipower=false/' system.prop; #Disable WiPower
+ #Disable IMS
+ #sed -i 's/persist.data.iwlan.enable=true/persist.data.iwlan.enable=false/' system.prop;
+ #sed -i 's/persist.ims.volte=true/persist.ims.volte=false/' system.prop;
+ #sed -i 's/persist.ims.vt=true/persist.ims.vt=false/' system.prop;
+ #sed -i 's/persist.radio.calls.on.ims=true/persist.radio.calls.on.ims=false/' system.prop;
+ #sed -i 's/persist.radio.hw_mbn_update=./persist.radio.hw_mbn_update=0/' system.prop;
+ #sed -i 's/persist.radio.jbims=./persist.radio.jbims=0/' system.prop;
+ #sed -i 's/persist.radio.sw_mbn_update=./persist.radio.sw_mbn_update=0/' system.prop;
+ #sed -i 's/persist.radio.sw_mbn_volte=./persist.radio.sw_mbn_volte=0/' system.prop;
+ #sed -i 's/persist.radio.VT_ENABLE=./persist.radio.VT_ENABLE=0/' system.prop;
+ #sed -i 's/persist.radio.VT_HYBRID_ENABLE=./persist.radio.VT_HYBRID_ENABLE=0/' system.prop;
+ #sed -i 's/persist.volte_enabled_by_hw=./persist.volte_enabled_by_hw=0/' system.prop;
+ fi;
+ if [ -f configs/qmi_config.xml ]; then
+ sed -i 's|name="dpm_enabled" type="int"> 1 <|name="dpm_enabled" type="int"> 0 <|' configs/qmi_config.xml; #Disable DPM
+ fi;
+ if [ -f init/init_*.cpp ]; then
+ sed -i 's/property_set("persist.rcs.supported", ".");/property_set("persist.rcs.supported", "0");/' init/init_*.cpp; #Disable RCS
+ #Disable IMS
+ #sed -i 's/property_set("persist.ims.volte", "true");/property_set("persist.ims.volte", "false");/' init/init_*.cpp;
+ #sed -i 's/property_set("persist.ims.vt", "true");/property_set("persist.ims.vt", "false");/' init/init_*.cpp;
+ #sed -i 's/property_set("persist.radio.calls.on.ims", "true");/property_set("persist.radio.calls.on.ims", "false");/' init/init_*.cpp;
+ #sed -i 's/property_set("persist.radio.jbims", ".");/property_set("persist.radio.jbims", "0");/' init/init_*.cpp;
+ #sed -i 's/property_set("persist.radio.VT_ENABLE", ".");/property_set("persist.radio.VT_ENABLE", "0");/' init/init_*.cpp;
+ #sed -i 's/property_set("persist.radio.VT_HYBRID_ENABLE", ".");/property_set("persist.radio.VT_HYBRID_ENABLE", "0");/' init/init_*.cpp;
+ fi;
+ if [ -f overlay/frameworks/base/core/res/res/values/config.xml ]; then
+ awk -i inplace '!/'$overlay'/' overlay/frameworks/base/core/res/res/values/config.xml;
+ #sed -i 's|true|false|' overlay/frameworks/base/core/res/res/values/config.xml;
+ sed -i 's|true|false|' overlay/frameworks/base/core/res/res/values/config.xml; #Disable UIBlur
+ #Disable IMS
+ #sed -i 's|true|false|' overlay/frameworks/base/core/res/res/values/config.xml;
+ #sed -i 's|true|false|' overlay/frameworks/base/core/res/res/values/config.xml;
+ #sed -i 's|true|false|' overlay/frameworks/base/core/res/res/values/config.xml;
+ #sed -i 's|true|false|' overlay/frameworks/base/core/res/res/values/config.xml;
+ #sed -i 's|true|false|' overlay/frameworks/base/core/res/res/values/config.xml;
+ fi;
+ if [ -d sepolicy ]; then
+ if [ -z "$replaceTime" ]; then
+ #Switch to Sony TimeKeep
+ echo "allow system_app time_data_file:dir { create_dir_perms search };" >> sepolicy/system_app.te;
+ echo "allow system_app time_data_file:file create_file_perms;" >> sepolicy/system_app.te;
+ fi;
+ fi;
+ if [ -z "$replaceTime" ]; then sed -i 's|service time_daemon /system/bin/time_daemon|service timekeep /system/bin/timekeep restore\n oneshot|' init.*.rc rootdir/init.*.rc rootdir/etc/init.*.rc &> /dev/null || true; fi; #Switch to Sony TimeKeep
+ rm -f board/qcom-cne.mk product/qcom-cne.mk; #Remove CNE
+ rm -f rootdir/etc/init.qti.ims.sh rootdir/init.qti.ims.sh init.qti.ims.sh; #Remove IMS startup script
+ rm -rf IMSEnabler; #Remove IMS compatibility module
+ #rm -rf data-ipa-cfg-mgr; #Remove IPA
+ rm -rf libshimwvm libshims/wvm_shim.cpp; #Remove Google Widevine compatibility module
+ rm -rf board/qcom-wipower.mk product/qcom-wipower.mk; #Remove WiPower makefiles
+ if [ -f setup-makefiles.sh ]; then
+ awk -i inplace '!/'$blobs'/' *proprietary*.txt; #Remove all blob references from blob manifest
+ bash -c "cd $base$devicePath && ./setup-makefiles.sh"; #Update the makefiles
+ fi;
+ cd $base;
+}
+export -f deblobDevice;
+
+deblobKernel() {
+ kernelPath=$1;
+ cd $base$kernelPath;
+ rm -rf $kernels;
+ cd $base;
+}
+export -f deblobKernel;
+
+deblobVendors() {
+ cd $base;
+ find vendor -regextype posix-extended -regex '.*('$blobs')' -type f -delete; #Delete all blobs
+}
+export -f deblobVendors;
+
+deblobVendor() {
+ makefile=$1;
+ cd $base;
+ awk -i inplace '!/'$blobs'/' $makefile; #Remove all blob references from makefile
+}
+export -f deblobVendor;
+#
+#END OF FUNCTIONS
+#
+
+
+#
+#START OF DEBLOBBING
+#
+find device -maxdepth 2 -mindepth 2 -type d -exec bash -c 'deblobDevice "$0"' {} \; #Deblob all device directories
+#find kernel -maxdepth 2 -mindepth 2 -type d -exec bash -c 'deblobKernel "$0"' {} \; #Deblob all kernel directories
+find vendor -name "*vendor*.mk" -type f -exec bash -c 'deblobVendor "$0"' {} \; #Deblob all makefiles
+deblobVendors; #Deblob entire vendor directory
+rm -rf frameworks/av/drm/mediadrm/plugins/clearkey; #Remove Clearkey
+rm -rf vendor/samsung/nodevice;
+#
+#END OF DEBLOBBING
+#
+
+#Fixes marlin building, really janky (recursive symlinks) and probably not the best place for it [LAOS SPECIFIC]
+cd vendor/google/marlin/proprietary;
+ln -s . vendor;
+ln -s . lib/lib;
+ln -s . lib64/lib64;
+ln -s . app/app;
+ln -s . bin/bin;
+ln -s . etc/etc;
+ln -s . framework/framework;
+ln -s . priv-app/priv-app;
+cd $base;
+
+echo "Deblobbing complete!"
diff --git a/Scripts/LineageOS-15.1/Defaults.sh b/Scripts/LineageOS-15.1/Defaults.sh
new file mode 100644
index 00000000..8a6ede24
--- /dev/null
+++ b/Scripts/LineageOS-15.1/Defaults.sh
@@ -0,0 +1,54 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2017-2018 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+#Changes various default settings
+
+echo "Changing default settings..."
+
+enter "frameworks/base"
+sed -i '0,/wifi,cell,battery/s/wifi,cell,battery,dnd,flashlight,rotation,bt,airplane/wifi,cell,bt,dnd,flashlight,rotation,battery,profiles,location,airplane,saver,hotspot,nfc/' packages/SystemUI/res/values/config.xml; #Default quick tiles
+#sed -i 's|config_longPressOnHomeBehavior">2|config_longPressOnHomeBehavior">0|' core/res/res/values/config.xml; #Set long press home to do nothing
+#sed -i 's|config_doubleTapOnHomeBehavior">0|config_doubleTapOnHomeBehavior">8|' core/res/res/values/config.xml; #Set double tap home to switch to last app
+
+enter "packages/apps/Dialer"
+sed -i 's/FLP_DEFAULT = FLP_GOOGLE;/FLP_DEFAULT = FLP_OPENSTREETMAP;/' src/com/android/dialer/lookup/LookupSettings.java; #Change FLP to OpenStreetMap
+sed -i 's/CMSettings.System.ENABLE_FORWARD_LOOKUP, 1)/CMSettings.System.ENABLE_FORWARD_LOOKUP, 0)/' src/com/android/dialer/lookup/LookupSettings.java; #Disable FLP
+sed -i 's/CMSettings.System.ENABLE_PEOPLE_LOOKUP, 1)/CMSettings.System.ENABLE_PEOPLE_LOOKUP, 0)/' src/com/android/dialer/lookup/LookupSettings.java; #Disable PLP
+sed -i 's/CMSettings.System.ENABLE_REVERSE_LOOKUP, 1)/CMSettings.System.ENABLE_REVERSE_LOOKUP, 0)/' src/com/android/dialer/lookup/LookupSettings.java; #Disable RLP
+
+enter "packages/apps/FDroid"
+sed -i 's|DEFAULT_ROOTED = true;|DEFAULT_ROOTED = false;|' app/src/main/java/org/fdroid/fdroid/Preferences.java; #Hide root apps
+sed -i '/string\/rooted/!b;n;s/defaultValue="true"/defaultValue="false"/' app/src/main/res/xml/preferences.xml;
+sed -i 's|DEFAULT_HIDE_ANTI_FEATURE_APPS = false;|DEFAULT_HIDE_ANTI_FEATURE_APPS = true;|' app/src/main/java/org/fdroid/fdroid/Preferences.java; #Hide anti-feature apps
+sed -i '/string\/hide_anti_feature_apps/!b;n;s/defaultValue="false"/defaultValue="true"/' app/src/main/res/xml/preferences.xml;
+
+enter "packages/apps/Nfc"
+sed -i 's/static final boolean NFC_ON_DEFAULT = true;/static final boolean NFC_ON_DEFAULT = false;/' src/com/android/nfc/NfcService.java; #Disable NFC
+sed -i 's/static final boolean NDEF_PUSH_ON_DEFAULT = true;/static final boolean NDEF_PUSH_ON_DEFAULT = false;/' src/com/android/nfc/NfcService.java; #Disable NDEF Push
+
+enter "packages/apps/Settings"
+sed -i 's/Settings.Secure.WEB_ACTION_ENABLED, 1/Settings.Secure.WEB_ACTION_ENABLED, 0/' src/com/android/settings/applications/ManageDomainUrls.java; #Disable "Instant Apps"
+sed -i 's/Float.parseFloat(newValue.toString()) : 1;/Float.parseFloat(newValue.toString()) : 0.5f;/' src/com/android/settings/DevelopmentSettings.java; #Always reset animation scales to 0.5
+
+enter "packages/apps/Trebuchet"
+sed -i 's|homescreen_search_default">true|homescreen_search_default">false|' res/values/preferences_defaults.xml; #Disable search
+sed -i 's|drawer_compact_default">false|drawer_compact_default">true|' res/values/preferences_defaults.xml; #Enable compact view
+sed -i 's|use_scroller_default">true|use_scroller_default">false|' res/values/preferences_defaults.xml; #Hide scroller
+sed -i 's|drawer_search_default">true|drawer_search_default">false|' res/values/preferences_defaults.xml; #Disable search
+
+cd $base
+echo "Default settings changed!"
diff --git a/Scripts/LineageOS-15.1/Functions.sh b/Scripts/LineageOS-15.1/Functions.sh
new file mode 100644
index 00000000..330f6ac8
--- /dev/null
+++ b/Scripts/LineageOS-15.1/Functions.sh
@@ -0,0 +1,215 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2017-2018 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+startPatcher() {
+ java -jar $cvePatcher patch $base $androidWorkspace"Patches/" $cveScripts $1;
+}
+export -f startPatcher;
+
+patchAllKernels() {
+ startPatcher "";
+}
+export -f patchAllKernels;
+
+enter() {
+ echo "================================================================================================"
+ dir=$1;
+ cd $base$dir;
+ echo "[ENTERING] "$dir;
+}
+export -f enter;
+
+enterAndClear() {
+ enter $1;
+ gitReset;
+}
+export -f enterAndClear;
+
+gitReset() {
+ git add -A && git reset --hard;
+}
+export -f gitReset;
+
+resetWorkspace() {
+ repo forall -c 'git add -A && git reset --hard' && rm -rf packages/apps/{FDroid,GmsCore,Silence} out && repo sync -j20 --force-sync;
+}
+export -f resetWorkspace;
+
+buildDevice() {
+ brunch lineage_$1-user;
+}
+export -f buildDevice;
+
+buildAll() {
+#Select devices are userdebug due to SELinux policy issues
+#TODO: Add victara, griffin, athene, us997, us996, pme, t0lte, hlte
+}
+export -f buildAll;
+
+buildAllN03() {
+ brunch lineage_flo-user; #Not affected by size, but breaks: undefined reference to 'mm_jpeg_get_new_session_idx'
+}
+export -f buildAllN03;
+
+patchWorkspace() {
+ source $scripts/Patch.sh;
+ source $scripts/Defaults.sh;
+# source $scripts/Overclock.sh;
+ source $scripts/Optimize.sh;
+ source $scripts/Rebrand.sh;
+ source $scripts/Theme.sh;
+ source $scripts/Deblob.sh;
+ source $scripts/Patch_CVE.sh;
+ source build/envsetup.sh;
+}
+export -f patchWorkspace;
+
+enableDexPreOpt() {
+ cd $base$1;
+ if [ $1 != "device/amazon/thor" ] && [ $1 != "device/samsung/i9100" ] && [ $1 != "device/lge/h850" ]; then #Some devices won't compile, or have too small of a /system partition
+ if [ -f BoardConfig.mk ]; then
+ echo "WITH_DEXPREOPT := true" >> BoardConfig.mk;
+ echo "WITH_DEXPREOPT_PIC := true" >> BoardConfig.mk;
+ echo "WITH_DEXPREOPT_BOOT_IMG_ONLY := true" >> BoardConfig.mk;
+ echo "Enabled dexpreopt for $1";
+ fi;
+ fi;
+ cd $base;
+}
+export -f enableDexPreOpt;
+
+enableDexPreOptFull() {
+ if [ -f BoardConfig.mk ]; then
+ sed -i "s/WITH_DEXPREOPT_BOOT_IMG_ONLY := true/WITH_DEXPREOPT_BOOT_IMG_ONLY := false/" BoardConfig.mk;
+ echo "Enabled full dexpreopt";
+ fi;
+}
+export -f enableDexPreOptFull;
+
+enhanceLocation() {
+ cd $base$1;
+ #Enable GLONASS
+ #sed -i 's/#A_GLONASS_POS_PROTOCOL_SELECT/A_GLONASS_POS_PROTOCOL_SELECT/' gps.conf gps/gps.conf configs/gps.conf &>/dev/null || true;
+ #sed -i 's/A_GLONASS_POS_PROTOCOL_SELECT = 0.*/A_GLONASS_POS_PROTOCOL_SELECT = 15/' gps.conf gps/gps.conf configs/gps.conf &>/dev/null || true;
+ #sed -i 's|A_GLONASS_POS_PROTOCOL_SELECT=0.*|A_GLONASS_POS_PROTOCOL_SELECT=15|' overlay/frameworks/base/core/res/res/values-*/*.xml &>/dev/null || true;
+ #Recommended reading: https://wwws.nightwatchcybersecurity.com/2016/12/05/cve-2016-5341/
+ #XTRA: Only use specified URLs
+ sed -i 's|XTRA_SERVER_QUERY=1|XTRA_SERVER_QUERY=0|' gps.conf gps/gps.conf configs/gps.conf &>/dev/null || true;
+ sed -i 's|#XTRA_SERVER|XTRA_SERVER|' gps.conf gps/gps.conf configs/gps.conf &>/dev/null || true;
+ #XTRA: Enable HTTPS
+ sed -i 's|http://xtra|https://xtra|' overlay/frameworks/base/core/res/res/values-*/*.xml gps.conf gps/gps.conf configs/gps.conf &>/dev/null || true;
+ #XTRA: Use format version 3 if possible
+ if grep -sq "XTRA_VERSION_CHECK" gps.conf gps/gps.conf configs/gps.conf; then #Using hardware/qcom/gps OR precompiled blob OR device specific implementation
+ sed -i 's|XTRA_VERSION_CHECK=0|XTRA_VERSION_CHECK=1|' gps.conf gps/gps.conf configs/gps.conf &>/dev/null || true;
+ sed -i 's|xtra2.bin|xtra3grc.bin|' gps.conf gps/gps.conf configs/gps.conf &>/dev/null || true;
+ elif grep -sq "BOARD_VENDOR_QCOM_LOC_PDK_FEATURE_SET := true" BoardConfig.mk boards/*gps.mk; then
+ if ! grep -sq "USE_DEVICE_SPECIFIC_LOC_API := true" BoardConfig.mk boards/*gps.mk; then
+ if ! grep -sq "libloc" *proprietary*.txt; then #Using hardware/qcom/gps
+ sed -i 's|xtra2.bin|xtra3grc.bin|' gps.conf gps/gps.conf configs/gps.conf &>/dev/null || true;
+ fi;
+ fi;
+ fi;
+ echo "Enhanced location services for $1";
+ cd $base;
+}
+export -f enhanceLocation;
+
+enableZram() {
+ cd $base$1;
+ sed -i 's|#/dev/block/zram0|/dev/block/zram0|' fstab.* root/fstab.* rootdir/fstab.* rootdir/etc/fstab.* &>/dev/null || true;
+ echo "Enabled zram for $1";
+ cd $base;
+}
+export -f enableZram;
+
+enableForcedEncryption() {
+ cd $base$1;
+ if [[ $1 != "device/lge/mako" ]]; then #Forced encryption seems to prevent some devices from booting
+ sed -i 's|encryptable=/|forceencrypt=/|' fstab.* root/fstab.* rootdir/fstab.* rootdir/etc/fstab.* &>/dev/null || true;
+ echo "Enabled forceencrypt for $1";
+ fi;
+ cd $base;
+}
+export -f enableForcedEncryption;
+
+enableStrongEncryption() {
+ cd $base$1;
+ if [ -f BoardConfig.mk ]; then
+ echo "TARGET_WANTS_STRONG_ENCRYPTION := true" >> BoardConfig.mk;
+ echo "Enabled AES-256 encryption for $1";
+ fi;
+ cd $base;
+}
+export -f enableStrongEncryption;
+
+getDefconfig() {
+ if ls arch/arm/configs/lineage*defconfig 1> /dev/null 2>&1; then
+ defconfigPath="arch/arm/configs/lineage*defconfig";
+ elif ls arch/arm64/configs/lineage*defconfig 1> /dev/null 2>&1; then
+ defconfigPath="arch/arm64/configs/lineage*defconfig";
+ else
+ defconfigPath="arch/arm/configs/*defconfig arch/arm64/configs/*defconfig";
+ fi;
+ echo $defconfigPath;
+ #echo "Found defconfig at $defconfigPath"
+}
+export -f getDefconfig;
+
+editKernelLocalversion() {
+ defconfigPath=$(getDefconfig)
+ sed -i 's/CONFIG_LOCALVERSION=".*"/CONFIG_LOCALVERSION="'$1'"/' $defconfigPath &>/dev/null || true;
+}
+export -f editKernelLocalversion;
+
+hardenDefconfig() {
+ cd $base$1;
+
+ #Attempts to enable/disable supported options to increase security
+ #See https://kernsec.org/wiki/index.php/Kernel_Self_Protection_Project/Recommended_Settings
+
+ defconfigPath=$(getDefconfig)
+
+ #Enable supported options
+ #Disabled: CONFIG_DEBUG_SG (bootloops - https://patchwork.kernel.org/patch/8989981)
+ declare -a optionsYes=("CONFIG_ARM64_SW_TTBR0_PAN" "CONFIG_BUG" "CONFIG_BUG_ON_DATA_CORRUPTION" "CONFIG_CC_STACKPROTECTOR" "CONFIG_CC_STACKPROTECTOR_STRONG" "CONFIG_CPU_SW_DOMAIN_PAN" "CONFIG_DEBUG_CREDENTIALS" "CONFIG_DEBUG_KERNEL" "CONFIG_DEBUG_LIST" "CONFIG_DEBUG_NOTIFIERS" "CONFIG_DEBUG_RODATA" "CONFIG_DEBUG_WX" "CONFIG_FORTIFY_SOURCE" "CONFIG_GCC_PLUGIN_LATENT_ENTROPY" "CONFIG_GCC_PLUGIN_RANDSTRUCT" "CONFIG_GCC_PLUGINS" "CONFIG_GCC_PLUGIN_STRUCTLEAK" "CONFIG_GCC_PLUGIN_STRUCTLEAK_BYREF_ALL" "CONFIG_HARDENED_USERCOPY" "CONFIG_IO_STRICT_DEVMEM" "CONFIG_KAISER" "CONFIG_LEGACY_VSYSCALL_NONE" "CONFIG_PAGE_POISONING" "CONFIG_PAGE_POISONING_NO_SANITY" "CONFIG_PAGE_POISONING_ZERO" "CONFIG_PAGE_TABLE_ISOLATION" "CONFIG_PANIC_ON_OOPS" "CONFIG_RANDOMIZE_BASE" "CONFIG_REFCOUNT_FULL" "CONFIG_RETPOLINE" "CONFIG_SCHED_STACK_END_CHECK" "CONFIG_SECCOMP" "CONFIG_SECCOMP_FILTER" "CONFIG_SECURITY" "CONFIG_SECURITY_PERF_EVENTS_RESTRICT" "CONFIG_SECURITY_YAMA" "CONFIG_SECURITY_YAMA_STACKED" "CONFIG_SLAB_FREELIST_RANDOM" "CONFIG_SLAB_HARDENED" "CONFIG_SLUB_DEBUG" "CONFIG_STRICT_DEVMEM" "CONFIG_STRICT_KERNEL_RWX" "CONFIG_STRICT_MEMORY_RWX" "CONFIG_SYN_COOKIES" "CONFIG_UNMAP_KERNEL_AT_EL0" "CONFIG_VMAP_STACK")
+ for option in "${optionsYes[@]}"
+ do
+ sed -i 's/# '$option' is not set/'$option'=y/' $defconfigPath &>/dev/null || true;
+ #Some defconfigs are very minimal/not-autogenerated, so lets add the rest. Obviously most won't have any affect as they aren't supported.
+ if [[ $defconfigPath == *"lineage"* ]]; then
+ if ! grep -q $option"=y" $defconfigPath; then
+ echo $option"=y" | tee -a $defconfigPath > /dev/null;
+ fi;
+ fi;
+ done
+ #Disable supported options
+ #TODO: Disable earjack/uart debugger
+ declare -a optionsNo=("CONFIG_ACPI_CUSTOM_METHOD" "CONFIG_BINFMT_MISC" "CONFIG_COMPAT_BRK" "CONFIG_COMPAT_VDSO" "CONFIG_CP_ACCESS64" "CONFIG_DEVKMEM" "CONFIG_DEVMEM" "CONFIG_DEVPORT" "CONFIG_HIBERNATION" "CONFIG_INET_DIAG" "CONFIG_KEXEC" "CONFIG_LEGACY_PTYS" "CONFIG_MSM_BUSPM_DEV" "CONFIG_OABI_COMPAT" "CONFIG_PROC_KCORE" "CONFIG_PROC_VMCORE" "CONFIG_SECURITY_SELINUX_DISABLE" "CONFIG_SLAB_MERGE_DEFAULT")
+ for option in "${optionsNo[@]}"
+ do
+ sed -i 's/'$option'=y/# '$option' is not set/' $defconfigPath &>/dev/null || true;
+ done
+ #Extras
+ sed -i 's/CONFIG_DEFAULT_MMAP_MIN_ADDR=4096/CONFIG_DEFAULT_MMAP_MIN_ADDR=32768/' $defconfigPath &>/dev/null || true;
+ sed -i 's/CONFIG_LSM_MMAP_MIN_ADDR=4096/CONFIG_DEFAULT_MMAP_MIN_ADDR=32768/' $defconfigPath &>/dev/null || true;
+
+ editKernelLocalversion "-dos";
+
+ echo "Hardened defconfig for $1";
+ cd $base;
+}
+export -f hardenDefconfig;
diff --git a/Scripts/LineageOS-15.1/Optimize.sh b/Scripts/LineageOS-15.1/Optimize.sh
new file mode 100644
index 00000000..34fe51de
--- /dev/null
+++ b/Scripts/LineageOS-15.1/Optimize.sh
@@ -0,0 +1,38 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2017-2018 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+#Attempts to increase performance and battery life
+
+echo "Optimizing..."
+
+enter "frameworks/base"
+sed -i 's/ScaleSetting = 1.0f;/ScaleSetting = 0.5f;/' services/core/java/com/android/server/wm/WindowManagerService.java;
+sed -i 's|config_useVolumeKeySounds">true|config_useVolumeKeySounds">false|' core/res/res/values/config.xml;
+sed -i 's|config_radioScanningTimeout">0|config_radioScanningTimeout">300000|' core/res/res/values/config.xml;
+sed -i 's|config_wifi_fast_bss_transition_enabled">false|config_wifi_fast_bss_transition_enabled">true|' core/res/res/values/config.xml;
+sed -i 's|config_wifi_enable_wifi_firmware_debugging">true|config_wifi_enable_wifi_firmware_debugging">false|' core/res/res/values/config.xml;
+sed -i 's|config_wifi_supplicant_scan_interval">15000|config_wifi_supplicant_scan_interval">120000|' core/res/res/values/config.xml;
+sed -i 's|config_autoBrightnessLightSensorRate">250|config_autoBrightnessLightSensorRate">1000|' core/res/res/values/config.xml;
+#sed -i 's|config_buttonLightOnKeypressOnly">false|config_buttonLightOnKeypressOnly">true|' core/res/res/values/config.xml;
+sed -i 's|config_recents_use_hardware_layers">false|config_recents_use_hardware_layers">true|' packages/SystemUI/res/values/config.xml;
+sed -i 's|config_recents_fake_shadows">false|config_recents_fake_shadows">true|' packages/SystemUI/res/values/config.xml;
+sed -i 's|config_notifications_round_rect_clipping">true|config_notifications_round_rect_clipping">false|' packages/SystemUI/res/values/config.xml;
+sed -i 's|config_showTemperatureWarning">0|config_showTemperatureWarning">1|' packages/SystemUI/res/values/config.xml; #XXX: Doesn't seem to work?
+#sed -i 's|||'
+
+cd $base
+echo "Optimizing complete!"
diff --git a/Scripts/LineageOS-15.1/Overclock.sh b/Scripts/LineageOS-15.1/Overclock.sh
new file mode 100644
index 00000000..4f2def62
--- /dev/null
+++ b/Scripts/LineageOS-15.1/Overclock.sh
@@ -0,0 +1,58 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2017-2018 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+#Overclocks the CPU to increase performance
+
+echo "Applying overclocks..."
+
+enter "kernel/huawei/angler"
+patch -p1 < $patches"android_kernel_huawei_angler/0001-Overclock.patch"
+
+enter "kernel/lge/bullhead"
+patch -p1 < $patches"android_kernel_common_msm8992/0001-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0002-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0003-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0004-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0005-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0006-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0007-Overclock.patch"
+
+enter "kernel/lge/g3"
+patch -p1 < $patches"android_kernel_lge_g3/0001-Overclock.patch" #2.45Ghz -> 2.76Ghz =+1.24Ghz
+patch -p1 < $patches"android_kernel_lge_g3/0002-Overclock.patch"
+patch -p1 < $patches"android_kernel_lge_g3/0003-Overclock.patch"
+patch -p1 < $patches"android_kernel_lge_g3/0004-Overclock.patch"
+
+enter "kernel/lge/hammerhead"
+patch -p1 < $patches"android_kernel_lge_hammerhead/0001-Overclock.patch" #2.26Ghz -> 2.95Ghz =+2.76Ghz XXX: Untested!
+
+enter "kernel/lge/msm8992"
+patch -p1 < $patches"android_kernel_common_msm8992/0001-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0003-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0004-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0005-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0006-Overclock.patch"
+patch -p1 < $patches"android_kernel_common_msm8992/0007-Overclock.patch"
+
+#enter "kernel/motorola/msm8916"
+#patch -p1 < $patches"android_kernel_motorola_msm8916/0001-Overclock.patch" #1.36Ghz -> 1.88Ghz =+ 2.07Ghz
+
+enter "kernel/oppo/msm8974"
+patch -p1 < $patches"android_kernel_oneplus_msm8974/0001-OverUnderClock-EXTREME.patch" #300Mhz -> 268Mhz, 2.45Ghz -> 2.95Ghz =+2.02Ghz XXX: Not 100% stable under intense workloads
+
+cd $base
+echo "Overclocks applied!"
diff --git a/Scripts/LineageOS-15.1/Patch.sh b/Scripts/LineageOS-15.1/Patch.sh
new file mode 100755
index 00000000..458ba72c
--- /dev/null
+++ b/Scripts/LineageOS-15.1/Patch.sh
@@ -0,0 +1,222 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2015-2018 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+#Initialize aliases
+#source ../../Scripts/LineageOS-15.1/00init.sh
+
+#Delete Everything and Sync
+#resetWorkspace
+
+#Apply all of our changes
+#patchWorkspace
+
+#Build!
+#buildDevice [device]
+#buildAll
+
+#Generate an incremental
+#./build/tools/releasetools/ota_from_target_files --block -t 8 -i old.zip new.zip update.zip
+
+#Generate firmware deblobber
+#mka firmware_deblobber
+
+#
+#START OF PREPRATION
+#
+#Download some (non-executable) out-of-tree files for use later on
+mkdir /tmp/ar
+cd /tmp/ar
+wget https://spotco.us/hosts -N #XXX: /hosts is built from non-commercial use files, switch to /hsc for release
+
+#Accept all SDK licences, not normally needed but Gradle managed apps fail without it
+mkdir -p "$ANDROID_HOME/licenses"
+echo -e "\n8933bad161af4178b1185d1a37fbf41ea5269c55\nd56f5187479451eabf01fb78af6dfcb131a6481e" > "$ANDROID_HOME/licenses/android-sdk-license"
+echo -e "\n84831b9409646a918e30573bab4c9c91346d8abd" > "$ANDROID_HOME/licenses/android-sdk-preview-license"
+#
+#END OF PREPRATION
+#
+
+#
+#START OF ROM CHANGES
+#
+
+#top dir
+cp -r $patches"Fennec_DOS-Shim" $base"packages/apps/"; #Add a shim to install Fennec DOS without actually including the large APK
+
+enterAndClear "bootable/recovery"
+#patch -p1 < $patches"android_bootable_recovery/0001-Squash_Menus.patch"; #What's a back button?
+
+enterAndClear "build"
+#patch -p1 < $patches"android_build/0001-Automated_Build_Signing.patch" #Automated build signing. Disclaimer: From CopperheadOS 13.0
+#patch -p1 < $patches"android_build/JustArchis_Optimizations-Rebased.patch" #JustArchi's Compiler Flags XXX: Breaks some devices, see buildAllN03()
+sed -i 's/messaging/Silence/' target/product/*.mk; #Replace AOSP Messaging app with Silence
+
+enterAndClear "device/qcom/sepolicy"
+#patch -p1 < $patches"android_device_qcom_sepolicy/0001-Camera_Fix.patch" #Fix camera on user builds
+
+enterAndClear "external/sqlite"
+#patch -p1 < $patches"android_external_sqlite/0001-Secure_Delete.patch" #Enable secure_delete by default. Disclaimer: From CopperheadOS 13.0
+
+enterAndClear "frameworks/base"
+#git revert 0326bb5e41219cf502727c3aa44ebf2daa19a5b3 #re-enable doze on devices without gms
+sed -i 's/DEFAULT_MAX_FILES = 1000;/DEFAULT_MAX_FILES = 0;/' services/core/java/com/android/server/DropBoxManagerService.java; #Disable DropBox
+sed -i 's/com.android.messaging/org.smssecure.smssecure/' core/res/res/values/config.xml; #Change default SMS app to Silence
+sed -i 's|db_default_journal_mode" translateble="false">PERSIST|db_default_journal_mode" translateble="false">TRUNCATE|' core/res/res/values/config.xml; #Mirror SQLite secure_delete
+sed -i 's|config_permissionReviewRequired">false|config_permissionReviewRequired">true|' core/res/res/values/config.xml;
+#patch -p1 < $patches"android_frameworks_base/0001-Reduced_Resolution.patch" #Allow reducing resolution to save power TODO: Add 800x480
+#patch -p1 < $patches"android_frameworks_base/0003-Signature_Spoofing.patch" #Allow packages to spoof their signature (MicroG)
+#patch -p1 < $patches"android_frameworks_base/0005-Harden_Sig_Spoofing.patch" #Restrict signature spoofing to system apps signed with the platform key
+#patch -p1 < $patches"android_frameworks_base/0006-OpenNIC.patch" #Change fallback and tethering DNS servers to OpenNIC AnyCast
+rm -rf packages/PrintRecommendationService; #App that just creates popups to install proprietary print apps
+rm core/res/res/values/config.xml.orig core/res/res/values/strings.xml.orig
+
+#enterAndClear "frameworks/opt/net/ims"
+#patch -p1 < $patches"android_frameworks_opt_net_ims/0001-Fix_Calling.patch" #Fix calling after we remove IMS
+
+enterAndClear "frameworks/opt/net/wifi"
+#Fix an issue when permision review is enabled that prevents using the Wi-Fi quick tile
+#See https://github.com/CopperheadOS/platform_frameworks_opt_net_wifi/commit/c2a2f077a902226093b25c563e0117e923c7495b
+sed -i 's/boolean mPermissionReviewRequired/boolean mPermissionReviewRequired = false/' service/java/com/android/server/wifi/WifiServiceImpl.java;
+awk -i inplace '!/mPermissionReviewRequired = Build.PERMISSIONS_REVIEW_REQUIRED/' service/java/com/android/server/wifi/WifiServiceImpl.java;
+awk -i inplace '!/\|\| context.getResources\(\).getBoolean\(/' service/java/com/android/server/wifi/WifiServiceImpl.java;
+awk -i inplace '!/com.android.internal.R.bool.config_permissionReviewRequired/' service/java/com/android/server/wifi/WifiServiceImpl.java;
+
+enterAndClear "packages/apps/DejaVu"
+cp $patches"android_packages_apps_DejaVu/Android.mk" Android.mk #Add a build file
+
+enterAndClear "packages/apps/FakeStore"
+sed -i 's|$(OUT_DIR)/target/|$(PWD)/$(OUT_DIR)/target/|' Android.mk;
+sed -i 's/ln -s /ln -sf /' Android.mk;
+sed -i 's/ext.androidBuildVersionTools = "24.0.3"/ext.androidBuildVersionTools = "25.0.3"/' build.gradle;
+
+enterAndClear "packages/apps/FDroid"
+git checkout 6260c11efc0f8296c19ee8d075cafbc556869cd1
+patch -p1 < $patches"android_packages_apps_FDroid/0001.patch" #Mark as privileged
+cp $patches"android_packages_apps_FDroid/default_repos.xml" app/src/main/res/values/default_repos.xml; #Add extra repos
+sed -i 's|gradle|./gradlew|' Android.mk; #Gradle 4.0 fix
+sed -i 's|/$(fdroid_dir) \&\&| \&\&|' Android.mk; #One line wouldn't work... no matter what I tried.
+
+enterAndClear "packages/apps/FDroidPrivilegedExtension"
+patch -p1 < $patches"android_packages_apps_FDroidPrivilegedExtension/0002-Release_Key.patch" #Change to release key
+#release-keys: CB:1E:E2:EC:40:D0:5E:D6:78:F4:2A:E7:01:CD:FA:29:EE:A7:9D:0E:6D:63:32:76:DE:23:0B:F3:49:40:67:C3
+#test-keys: C8:A2:E9:BC:CF:59:7C:2F:B6:DC:66:BE:E2:93:FC:13:F2:FC:47:EC:77:BC:6B:2B:0D:52:C1:1F:51:19:2A:B8
+
+enterAndClear "packages/apps/GmsCore"
+git submodule update --init --recursive
+sed -i 's|build/outputs/apk/play-services-core-release-unsigned.apk|build/outputs/apk/release/play-services-core-release-unsigned.apk|' Android.mk;
+
+enterAndClear "packages/apps/GsfProxy"
+sed -i 's/ext.androidBuildVersionTools = "24.0.3"/ext.androidBuildVersionTools = "25.0.3"/' build.gradle;
+
+enterAndClear "packages/apps/IchnaeaNlpBackend"
+sed -i 's|$(OUT_DIR)/target/|$(PWD)/$(OUT_DIR)/target/|' Android.mk;
+sed -i 's/compileSdkVersion 23/compileSdkVersion 25/' build.gradle;
+sed -i 's/buildToolsVersion "23.0.2"/buildToolsVersion "25.0.3"/' build.gradle;
+
+enterAndClear "packages/apps/LineageParts"
+rm -rf src/org/cyanogenmod/cmparts/cmstats/ res/xml/anonymous_stats.xml res/xml/preview_data.xml #Nuke part of CMStats
+sed -i 's|config_showWeatherMenu">true|config_showWeatherMenu">false|' res/values/config.xml; #Disable Weather
+#patch -p1 < $patches"android_packages_apps_CMParts/0001-Remove_Analytics.patch" #Remove the rest of CMStats
+#patch -p1 < $patches"android_packages_apps_CMParts/0002-Reduced_Resolution.patch" #Allow reducing resolution to save power
+
+enterAndClear "packages/apps/Settings"
+git revert 7caa1b691a137ba1a49cb258d774679229ee2de5
+sed -i 's/private int mPasswordMaxLength = 16;/private int mPasswordMaxLength = 48;/' src/com/android/settings/ChooseLockPassword.java; #Increase max password length
+sed -i 's/GSETTINGS_PROVIDER = "com.google.settings";/GSETTINGS_PROVIDER = "com.google.oQuae4av";/' src/com/android/settings/PrivacySettings.java; #MicroG doesn't support Backup, hide the options
+#patch -p1 < $patches"android_packages_apps_Settings/0001-Privacy_Guard-More_Perms.patch" #Allow more control over various permissions via Privacy Guard
+
+enterAndClear "packages/apps/SetupWizard"
+#patch -p1 < $patches"android_packages_apps_SetupWizard/0001-Remove_Analytics.patch" #Remove the rest of CMStats
+
+enterAndClear "packages/apps/Silence"
+cp $patches"android_packages_apps_Silence/Android.mk" Android.mk #Add a build file
+
+enterAndClear "packages/apps/Updater"
+#patch -p1 < $patches"android_packages_apps_Updater/0001-Server.patch" #Switch to our server
+
+enterAndClear "packages/apps/WallpaperPicker"
+#rm res/drawable-nodpi/{*.png,*.jpg} res/values-nodpi/wallpapers.xml; #Remove old ones
+#cp -r $dosWallpapers'Compressed/.' res/drawable-nodpi/; #Add ours
+#cp -r $dosWallpapers"Thumbs/." res/drawable-nodpi/;
+#cp $dosWallpapers"wallpapers.xml" res/values-nodpi/wallpapers.xml;
+sed -i 's/req.touchEnabled = touchEnabled;/req.touchEnabled = true;/' src/com/android/wallpaperpicker/WallpaperCropActivity.java; #Allow scrolling
+sed -i 's/mCropView.setTouchEnabled(req.touchEnabled);/mCropView.setTouchEnabled(true);/' src/com/android/wallpaperpicker/WallpaperCropActivity.java;
+sed -i 's/WallpaperUtils.EXTRA_WALLPAPER_OFFSET, 0);/WallpaperUtils.EXTRA_WALLPAPER_OFFSET, 0.5f);/' src/com/android/wallpaperpicker/WallpaperPickerActivity.java; #Center aligned by default
+
+enterAndClear "packages/inputmethods/LatinIME"
+#patch -p1 < $patches"android_packages_inputmethods_LatinIME/0001-Voice.patch" #Remove voice input key
+
+enterAndClear "packages/services/Telephony"
+#patch -p1 < $patches"android_packages_services_Telephony/0001-LTE_Only.patch" #LTE only preferred network mode choice. Disclaimer: From CopperheadOS before their LICENSE was added
+
+enterAndClear "system/core"
+cat /tmp/ar/hosts >> rootdir/etc/hosts #Merge in our HOSTS file
+#git revert 0217dddeb5c16903c13ff6c75213619b79ea622b d7aa1231b6a0631f506c0c23816f2cd81645b15f #Always update recovery
+#patch -p1 < $patches"android_system_core/0001-Harden_Mounts.patch" #Harden mounts with nodev/noexec/nosuid. Disclaimer: From CopperheadOS 13.0
+
+enterAndClear "system/vold"
+#patch -p1 < $patches"android_system_vold/0001-AES256.patch" #Add a variable for enabling AES-256 bit encryption
+
+enterAndClear "vendor/lineage"
+#rm -rf overlay/common/vendor/cmsdk/packages #Remove analytics
+awk -i inplace '!/50-cm.sh/' config/common.mk; #Make sure our hosts is always used
+patch -p1 < $patches"android_vendor_cm/0001-SCE.patch" #Include our extras such as MicroG and F-Droid
+cp $patches"android_vendor_cm/sce.mk" config/sce.mk
+cp $patches"android_vendor_cm/config.xml" overlay/common/vendor/cmsdk/cm/res/res/values/config.xml; #Per app performance profiles
+cp -r $patches"android_vendor_cm/firmware_deblobber" .;
+cp $patches"android_vendor_cm/firmware_deblobber.mk" build/tasks/firmware_deblobber.mk;
+sed -i 's/CM_BUILDTYPE := UNOFFICIAL/CM_BUILDTYPE := dos/' config/common.mk; #Change buildtype
+sed -i 's/messaging/Silence/' config/telephony.mk; #Replace AOSP Messaging app with Silence
+sed -i 's/config_enableRecoveryUpdater">false/config_enableRecoveryUpdater">true/' overlay/common/packages/apps/Settings/res/values/config.xml; #Expose option to update recovery
+#sed -i 's/mka bacon/mka bacon target-files-package dist/' build/envsetup.sh; #Create target-files for incrementals
+
+enterAndClear "vendor/lineage-sdk"
+awk -i inplace '!/WeatherManagerServiceBroker/' cm/res/res/values/config.xml; #Disable Weather
+cp $patches"cm_platform_sdk/profile_default.xml" cm/res/res/xml/profile_default.xml; #Replace default profiles with *way* better ones
+#patch -p1 < $patches"cm_platform_sdk/0001-Radio.patch" #Add a QS tile to control radio power
+sed -i 's/shouldUseOptimizations(weight)/true/' cm/lib/main/java/org/cyanogenmod/platform/internal/PerformanceManagerService.java; #Per app performance profiles fix
+#
+#END OF ROM CHANGES
+#
+
+#
+#START OF DEVICE CHANGES
+#
+enterAndClear "device/amazon/hdx-common"
+echo "/dev/block/platform/msm_sdcc.1/by-name/misc /misc emmc defaults defaults" >> rootdir/etc/fstab.qcom; #Add the misc (mmcblk0p5) partition for recovery flags
+
+enterAndClear "device/oneplus/bacon"
+sed -i "s/TZ.BF.2.0-2.0.0134/TZ.BF.2.0-2.0.0134|TZ.BF.2.0-2.0.0137/" board-info.txt; #Suport new TZ firmware https://review.lineageos.org/#/c/178999/
+
+#enterAndClear "kernel/lge/g3"
+#sed -i 's/39 01 00 00 00 00 04 F2 01 00 40/39 01 00 00 00 00 04 F2 01 00 00/' arch/arm/boot/dts/msm8974pro-lge-common/msm8974pro-lge-panel.dtsi; #Oversharpening fix, Credit: @Skin1980
+
+#Make changes to all devices
+cd $base
+find "device" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'enhanceLocation "$0"' {} \;
+find "device" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'enableDexPreOpt "$0"' {} \;
+find "device" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'enableForcedEncryption "$0"' {} \;
+#find "device" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'enableStrongEncryption "$0"' {} \;
+find "kernel" -maxdepth 2 -mindepth 2 -type d -exec bash -c 'hardenDefconfig "$0"' {} \;
+cd $base
+
+#Fix broken options enabled by hardenDefconfig()
+sed -i "s/CONFIG_DEBUG_RODATA=y/# CONFIG_DEBUG_RODATA is not set/" kernel/google/msm/arch/arm/configs/lineageos_*_defconfig; #Breaks on compile
+#sed -i "s/CONFIG_STRICT_MEMORY_RWX=y/# CONFIG_STRICT_MEMORY_RWX is not set/" kernel/lge/msm8996/arch/arm64/configs/lineageos_*_defconfig; #Breaks on compile
+#
+#END OF DEVICE CHANGES
+#
diff --git a/Scripts/LineageOS-15.1/Patch_CVE.sh b/Scripts/LineageOS-15.1/Patch_CVE.sh
new file mode 100644
index 00000000..5dc32daa
--- /dev/null
+++ b/Scripts/LineageOS-15.1/Patch_CVE.sh
@@ -0,0 +1,31 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2017 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+#Attempts to patch kernels to be more secure
+
+#Is this the best way to do it? No. Is it the proper way to do it? No. Do I wish device maintainers would do it? Yes. Is it better then nothing? YES!
+
+echo "Patching CVEs..."
+
+cd $base
+for patcher in $cveScripts/*.sh; do
+ echo "Running " $patcher;
+ source $patcher;
+done;
+
+cd $base
+echo "Patched CVEs!"
diff --git a/Scripts/LineageOS-15.1/Rebrand.sh b/Scripts/LineageOS-15.1/Rebrand.sh
new file mode 100644
index 00000000..8747f79d
--- /dev/null
+++ b/Scripts/LineageOS-15.1/Rebrand.sh
@@ -0,0 +1,48 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2017-2018 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+#Updates select user facing strings
+
+echo "Rebranding..."
+
+enter "bootable/recovery"
+sed -i 's|Android Recovery|DivestOS Recovery|' *_ui.cpp;
+
+enter "build"
+sed -i 's|echo "ro.build.user=$USER"|echo "ro.build.user=emy"|' tools/buildinfo.sh; #Override build user
+sed -i 's|echo "ro.build.host=`hostname`"|echo "ro.build.host=dosbm"|' tools/buildinfo.sh; #Override build host
+
+enter "packages/apps/Settings"
+sed -i '/.*cmlicense_title/s/LineageOS/DivestOS/' res/values*/cm_strings.xml
+sed -i '/.*cmupdate_settings_title/s/LineageOS/DivestOS/' res/values*/cm_strings.xml
+sed -i '/.*mod_version/s/LineageOS/DivestOS/' res/values*/cm_strings.xml
+
+enter "packages/apps/SetupWizard"
+sed -i 's|http://lineageos.org/legal|https://divestos.xyz/pages/legal/pp.html|' src/com/cyanogenmod/setupwizard/LineageSettingsActivity.java;
+sed -i '/.*setup_services/s/LineageOS/DivestOS/' res/values*/strings.xml
+sed -i '/.*services_explanation/s/LineageOS/DivestOS/' res/values*/strings.xml
+
+enter "packages/apps/Updater"
+sed -i 's|>LineageOS|>DivestOS|' res/values*/strings.xml
+
+enter "vendor/cm"
+sed -i 's|https://lineageos.org/legal|https://divestos.xyz/pages/about.html|' config/common.mk;
+#sed -i '/.*ZIPFILE=/s/lineage/divestos/' build/envsetup.sh
+rm -rf bootanimation #TODO: Create a boot animation
+
+cd $base
+echo "Rebranding complete!"
diff --git a/Scripts/LineageOS-15.1/Theme.sh b/Scripts/LineageOS-15.1/Theme.sh
new file mode 100644
index 00000000..4bbe89e2
--- /dev/null
+++ b/Scripts/LineageOS-15.1/Theme.sh
@@ -0,0 +1,75 @@
+#!/bin/bash
+#DivestOS: A privacy oriented Android distribution
+#Copyright (c) 2017-2018 Spot Communications, Inc.
+#
+#This program is free software: you can redistribute it and/or modify
+#it under the terms of the GNU General Public License as published by
+#the Free Software Foundation, either version 3 of the License, or
+#(at your option) any later version.
+#
+#This program is distributed in the hope that it will be useful,
+#but WITHOUT ANY WARRANTY; without even the implied warranty of
+#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+#GNU General Public License for more details.
+#
+#You should have received a copy of the GNU General Public License
+#along with this program. If not, see .
+
+#Replaces teal accents with orange/yellow ones
+
+echo "Applying theme..."
+
+export themeOverride50="FFCA28" #Amber 400
+export themeOverride100="FFC107" #Amber 500
+export themeOverride200="FFA726" #Orange 400
+export themeOverride300="FF9800" #Orange 500
+export themeOverride500="FF5722" #Deep Orange 500
+export themeOverride700="E64A19" #Deep Orange 700
+
+#export themeOverride50="26C6DA" #Cyan 400
+#export themeOverride100="00BCD4" #Cyan 500
+#export themeOverride200="29B6F6" #Light Blue 400
+#export themeOverride300="03A9F4" #Light Blue 500
+#export themeOverride500="2196F3" #Blue 500
+#export themeOverride700="1976D2" #Blue 700
+
+enter "frameworks/base"
+sed -i "s/#ffe0f2f1/#ff$themeOverride50/" core/res/res/values/colors_material.xml
+sed -i "s/#ffb2dfdb/#ff$themeOverride100/" core/res/res/values/colors_material.xml
+sed -i "s/#ff80cbc4/#ff$themeOverride200/" core/res/res/values/colors_material.xml
+sed -i "s/#ff4db6ac/#ff$themeOverride300/" core/res/res/values/colors_material.xml
+sed -i "s/#ff009688/#ff$themeOverride500/" core/res/res/values/colors_material.xml
+sed -i "s/#ff00796b/#ff$themeOverride700/" core/res/res/values/colors_material.xml
+sed -i "s/#fff4511e/#ffe53935/" core/res/res/values/colors.xml
+
+enter "packages/apps/GmsCore"
+sed -i "s/#ff7fcac3/#ff$themeOverride300/" microg-ui-tools/src/main/res/values/colors.xml
+sed -i "s/#ff009688/#ff$themeOverride500/" microg-ui-tools/src/main/res/values/colors.xml
+
+enter "packages/apps/LineageParts"
+sed -i "s/#ff009688/#ff$themeOverride500/" res/values/colors.xml
+
+enter "packages/apps/Settings"
+sed -i "s/#ff009688/#ff$themeOverride500/" res/values/styles.xml
+#TODO: Fix: Storage, Profiles
+
+enter "packages/apps/Trebuchet"
+sed -i "s/009688/$themeOverride500/" res/values/*colors.xml
+sed -i "s/009688/$themeOverride500/" WallpaperPicker/res/values/colors.xml
+mogrify -format png -fill "#$themeOverride500" -opaque "#009688" -fuzz 10% res/drawable*/cling_bg.9.png
+#TODO: Fix: Open app icon
+
+enter "packages/apps/Updater"
+sed -i "s/#ff009688/#ff$themeOverride500/" res/values/colors.xml
+
+enter "packages/inputmethods/LatinIME"
+sed -i "s/#80CBC4/#$themeOverride200/" java/res/values/colors.xml
+sed -i "s/#4DB6AC/#$themeOverride300/" java/res/values/colors.xml
+mogrify -format png -fill "#$themeOverride100" -opaque "#b2dfdb" -fuzz 10% java/res/drawable*/*lxx*.png
+mogrify -format png -fill "#$themeOverride200" -opaque "#80cbc4" -fuzz 10% java/res/drawable*/*lxx*.png
+mogrify -format png -fill "#$themeOverride300" -opaque "#4db6ac" -fuzz 10% java/res/drawable*/*lxx*.png
+mogrify -format png -fill "#$themeOverride300" -opaque "#7fcac3" -fuzz 10% java/res/drawable*/*lxx*.png
+mogrify -format png -fill "#$themeOverride400" -opaque "#26a69a" -fuzz 10% java/res/drawable*/*lxx*.png
+
+cd $base
+echo "Applied theme!"